// Molecule.java
// Bruno Bouzy
// 23 janvier 2003

import java.util.*;

class Molecule extends Entite { 

  public static VectorE mesInstances = new VectorE();
  public VectorE mesAtomes;

  public Molecule(String n) {
    super(n);
    mesAtomes = new VectorE();
    mesInstances.addElement(this);
  }

  public void detruire() { mesInstances.removeElement(this); }

  public String toString() { return ("\n"+toNom()+"\nMes atomes: "+mesAtomes.toNom()+"\n"); }

  public static void boucle() { while (menu()!='P'); }

  public static char menu() {
    System.out.println( "Molecule :");
    System.out.println( "\t C. Creation");
    System.out.println( "\t J. aJouter un atome");
    System.out.println( "\t R. Retirer un atome");
    System.out.println( "\t D. Destruction");
    System.out.println( "\t A. Affichage");
    System.out.println( "\t P. Precedent");
    char r = Keyboard.getChar();
    switch(r) {
    case 'C': creation(); break;
    case 'J': ajoutAtome(); break;
    case 'R': retraitAtome(); break;
    case 'D': destruction(); break;
    case 'A': System.out.println(mesInstances); break;
    }
    return r;
  }

  public static void creation() {
    System.out.println("\nCreation d'une molecule: "); 
    System.out.print("\nNom de la molecule ? "); 
    String s = Keyboard.getString();
    Molecule m = new Molecule(s);
    System.out.println("\nMolecule '" + s + "' creee."); 
  }

  public static void destruction() {
    System.out.print("\nDestruction d'une molecule: \n"); 
    System.out.print("\nNom de la molecule ? "); 
    String s = Keyboard.getString();
    Molecule m = (Molecule) mesInstances.getInstance(s);
    if (m!=null) {

      // Question 3: 'Molecule.destruction' 
      // OK:
      Atome.dereferencer(m.mesAtomes);
      // KO: rien

      m.detruire();
      System.out.println("\nMolecule '" + s + "' detruite.");
    }
    else System.out.println("\nPas de molecule avec le nom '" + s + "'.");
  }

  public static void ajoutAtome() {
    System.out.print("\nAjout d'un atome a une une molecule: \n"); 
    System.out.print("\nNom de la molecule ? "); 
    String sm = Keyboard.getString();
    Molecule m = (Molecule) mesInstances.getInstance(sm);
    if (m==null) {
      System.out.println("\nPas de molecule avec le nom '" + sm + "'.");
      return;
    }

    System.out.print("\nNom de l'atome ? "); 
    String sa = Keyboard.getString();
    Atome a = (Atome) Atome.mesInstances.getInstance(sa);
    if (a==null) {
	System.out.println("\nPas d'atome avec le nom '" + sa + "'.\n");
	return;
    }

    // Question 4: 'Molecule.AjoutAtome' 
    // OK:
    
    if (a.maMolecule!=null) {
      System.out.println("\nL'atome '" + sa + "' appartient deja a la molecule '" 
			 + a.maMolecule.toNom() + "'.");
      return;
    }
    
    // KO: rien

    m.mesAtomes.addElement(a);
    a.maMolecule = m;
    System.out.println("\nAtome '" + sa + "' ajoute a la molecule '" + sm + "'.");
  }

  public static void retraitAtome() {
    System.out.print("\nRetrait d'un atome d'une une molecule: \n"); 
    System.out.print("\nNom de la molecule ? "); 
    String sm = Keyboard.getString();
    Molecule m = (Molecule) mesInstances.getInstance(sm);
    if (m==null) {
      System.out.println("\nPas de molecule avec le nom '" + sm + "'.");
      return;
    }

    System.out.print("\nNom de l'atome ? "); 
    String sa = Keyboard.getString();

    // Question 5: 'Molecule.RetraitAtome'
    // KO:
    // Atome a = (Atome) Atome.mesInstances.getInstance(sa);
    // OK:
    Atome a = (Atome) m.mesAtomes.getInstance(sa);

    if (a==null) {
      System.out.println("\nPas d'atome avec le nom '" + sa + "'.");
      return;
    }

    m.mesAtomes.removeElement(a);
    a.maMolecule = null;
    System.out.println("\nAtome '" + sa + "' retire de la molecule '" + sm + "'.");
  }
}

